<?php
/**
*
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
*
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// Copyright (C) 2009 Jan Kulmann <jankul@zmml.uni-bremen.de>
// ATTENTION: Please send ALL bug reports and security leaks directly to the author.
//            Thx!
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+


class Artikel {

	var $titel;
	var $beschreibung;
	var $user_id;
	var $visible;
	var $public_visible;
	var $thema_id;
	var $artikel_id;
	var $mkdatum;
	var $subthema_id;

	function Artikel($id=FALSE) {
		if (!$id) {
			$this->titel = "";
			$this->beschreibung = "";
			$this->user_id = "";
			$this->visible = 1;
			$this->public_visible = 0;
			$this->thema_id = "";
			$this->artikel_id = "";
			$this->mkdatum = 0;
			$this->subthema_id = '';

		} else {
			$db = new DB_Seminar();
			$db->queryf("SELECT * FROM sb_artikel WHERE artikel_id='%s'",$id);
			if ($db->next_record()) {
				$this->titel = $db->f("titel");
	                        $this->beschreibung = $db->f("beschreibung");
        	                $this->user_id = $db->f("user_id");
                	        $this->visible = $db->f("visible");
                	        $this->public_visible = $db->f("public_visible");
	                        $this->thema_id = $db->f("thema_id");
        	                $this->artikel_id = $db->f("artikel_id");
				$this->mkdatum = $db->f("mkdate");
				$this->subthema_id = $db->f('subthema_id');
			}
		}
	}

	function save() {
		$db = new DB_Seminar();
		if ($this->thema_id != "" && $this->titel != "") {
			if ($this->artikel_id != "")
				$db->queryf("UPDATE sb_artikel SET titel='%s', beschreibung='%s', visible=%d, public_visible=%d, thema_id='%s', subthema_id='%s' WHERE artikel_id='%s'",$this->titel, mysql_escape_string($this->beschreibung), $this->visible, $this->public_visible, $this->thema_id, $this->subthema_id, $this->artikel_id);
			else {
				$id = md5(uniqid(time()));
				$this->artikel_id = $id;
				$db->queryf("INSERT INTO sb_artikel (artikel_id, thema_id, subthema_id, titel, user_id, mkdate, beschreibung, visible, public_visible) VALUES ('%s','%s','%s','%s','%s',UNIX_TIMESTAMP(),'%s', %d, %d)",$id,$this->thema_id,($this->subthema_id ? $this->subthema_id : ""), $this->titel,$GLOBALS['auth']->auth['uid'],mysql_escape_string($this->beschreibung),$this->visible, $this->public_visible);
				// assign standard tags
				$db->query("SELECT * FROM sb_tags WHERE owner='root'");
				$db2 = new DB_Seminar();
				$db3 = new DB_Seminar();
				while ($db->next_record()) {
					$db2->queryf("SELECT a.* FROM sb_artikel a WHERE a.artikel_id='%s' AND LOWER(a.titel) LIKE '%s' AND NOT EXISTS (SELECT ta.tag_id FROM sb_tag_artikel ta WHERE ta.tag_id='%s' AND ta.artikel_id=a.artikel_id)",$id,"%".$db->f('tag')."%", $db->f('tag_id'));
					while ($db2->next_record())
						$db3->queryf("INSERT INTO sb_tag_artikel (artikel_id, tag_id, mkdate) VALUES ('%s','%s',UNIX_TIMESTAMP())",$db2->f('artikel_id'),$db->f('tag_id'));
				}
			}
		}
	}

	function delete() {
		if ($this->artikel_id) {
			$db = new DB_Seminar();
			$db->queryf("DELETE FROM sb_artikel WHERE artikel_id='%s'",$this->artikel_id);
			$db->queryf("DELETE FROM sb_tag_artikel WHERE artikel_id='%s'",$this->artikel_id);
		}
	}

	function setTitel($s) {
		$this->titel = trim($s);
	}
	
	function setBeschreibung($s) {
		$this->beschreibung = trim($s);
	}
	
	function setUserId($s) {
		$this->user_id = $s;
	}

	function setVisible($s) {
		$this->visible = $s;
	}

	function setPublicVisible($s) {
		$this->public_visible = $s;
	}
	
	function setThemaId($s) {
		$this->thema_id = $s;
	}

	function setArtikelId($s) {
		$this->artikel_id = $s;
	}

	function setSubThemaId($s) {
		$this->subthema_id = $s;
	}

	function setTags($t) {
		$db = new DB_Seminar();
		$db2 = new DB_Seminar();
		if (trim($t) == "") return;
		$tags = explode(',',$t);
		$current_tags = $this->getTags();
		foreach ($tags as $t) {
			$t = trim(strtolower($t));
			if ($t == "") continue;
			if (in_array($t, $current_tags)) continue;
			$db->queryf("SELECT * FROM sb_tags WHERE tag='%s'",$t);
			if ($db->next_record()) {
				$db2->queryf("INSERT INTO sb_tag_artikel (artikel_id, tag_id, mkdate) VALUES ('%s','%s', UNIX_TIMESTAMP())", $this->artikel_id, $db->f('tag_id'));
			} else {
				$id = md5(uniqid(time().$this->artikel_id));
				$db2->queryf("INSERT INTO sb_tags (tag_id, tag) VALUES ('%s','%s')", $id, $t);
				$db2->queryf("INSERT INTO sb_tag_artikel (artikel_id, tag_id, mkdate) VALUES ('%s','%s', UNIX_TIMESTAMP())", $this->artikel_id, $id);
			}
			array_push($current_tags, $t);
		}
	}

	function getTitel() {
		return $this->titel;
	}

	function getBeschreibung() {
		return stripslashes($this->beschreibung);
	}

	function getUserId() {
		return $this->user_id;
	}

	function getVisible() {
		return $this->visible;
	}

	function getPublicVisible() {
		return $this->public_visible;
	}

	function getThemaId() {
		return $this->thema_id;
	}

	function getArtikelId() {
		return $this->artikel_id;
	}

	function getMkdate() {
		return $this->mkdatum;
	}

	function getSubThemaId() {
		return $this->subthema_id;
	}

	function getTags() {
		$ret = array();
		$db = new DB_Seminar();
		$db->queryf("SELECT tag FROM sb_tags t, sb_tag_artikel ta WHERE ta.artikel_id='%s' AND t.tag_id=ta.tag_id", $this->artikel_id);
		while ($db->next_record())
			array_push($ret, $db->f('tag'));
		return $ret;
	}

	function removeTag($tag) {
		if (!$this->artikel_id || !$tag) return;
		$db = new DB_Seminar();
		$db2 = new DB_Seminar();
		$db->queryf("SELECT ta.* FROM sb_tag_artikel ta, sb_tags t WHERE t.tag='%s' AND ta.tag_id=t.tag_id",$tag);
		$anz = $db->num_rows();
		$db->next_record();
		$db2->queryf("DELETE FROM sb_tag_artikel WHERE tag_id='%s' AND artikel_id='%s'",$db->f('tag_id'),$this->artikel_id);
		if ($anz == 1)
			$db2->queryf("DELETE FROM sb_tags WHERE tag_id='%s' AND owner!='root'",$db->f('tag_id'));
	}

}

?>
