<?php
/**
*
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
*
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// Copyright (C) 2009 Jan Kulmann <jankul@zmml.uni-bremen.de>
// ATTENTION: Please send ALL bug reports and security leaks directly to the author.
//            Thx!
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+

require_once 'Artikel.class.php';

class SBDBM {

	var $zeit;
	var $user_id;
	var $public_sql;

	function SBDBM($zeit) {
		$this->zeit = $zeit;
		$this->user_id = $GLOBALS['auth']->auth["uid"];
		$this->public_sql = ($this->user_id == 'nobody' ? "AND a.public_visible=1":"");
	}

	function search_query($txt) {
		$ret = array();
		$db = new DB_Seminar();
                /*$sql = sprintf("SELECT a.thema_id, a.artikel_id, a.titel, t.titel t_titel, a.mkdate FROM sb_artikel a, sb_themen t WHERE
                                t.thema_id=a.thema_id AND UPPER(a.titel) LIKE '%s' AND UNIX_TIMESTAMP() < (a.mkdate + %d)
                                AND (t.visible=1 OR (t.visible=0 AND 'root'='%s')) AND (a.visible=1 OR (a.visible=0 AND (a.user_id='%s' OR 'root'='%s'))) %s
                        ","%".strtoupper($txt)."%",$this->zeit,$GLOBALS['auth']->auth["perm"],$this->user_id,$GLOBALS['auth']->auth["perm"], $this->public_sql);
                $sql .= sprintf(" UNION SELECT a.thema_id, a.artikel_id, a.titel, t.titel t_titel, a.mkdate FROM sb_artikel a, sb_themen t, sb_tag_artikel ta, sb_tags tt WHERE
                                t.thema_id=a.thema_id AND UNIX_TIMESTAMP() < (a.mkdate + %d) AND 
                                ta.artikel_id=a.artikel_id AND tt.tag_id=ta.tag_id AND LOWER(tt.tag) LIKE '%s' 
                                AND (t.visible=1 OR (t.visible=0 AND 'root'='%s')) AND (a.visible=1 OR (a.visible=0 AND (a.user_id='%s' OR 'root'='%s'))) %s ORDER BY 4,5 DESC,3 
                        ",$this->zeit,"%".strtolower($txt)."%",$GLOBALS['auth']->auth["perm"],$this->user_id,$GLOBALS['auth']->auth["perm"], $this->public_sql);*/
		$sql = sprintf("SELECT a.thema_id, a.artikel_id, a.titel, t.titel t_titel, a.mkdate, IFNULL(s.titel,'Unsortiert') subthema, IFNULL(s.subthema_id,a.thema_id) subthema_id, IF(STRCMP(s.titel,''),9999,1) priority FROM sb_artikel a LEFT JOIN sb_subthemen s USING (subthema_id), sb_themen t WHERE
                                t.thema_id=a.thema_id AND UPPER(a.titel) LIKE '%s' AND UNIX_TIMESTAMP() < (a.mkdate + %d)
                                AND (t.visible=1 OR (t.visible=0 AND 'root'='%s')) AND (a.visible=1 OR (a.visible=0 AND (a.user_id='%s' OR 'root'='%s'))) %s
                        ","%".strtoupper($txt)."%",$this->zeit,$GLOBALS['auth']->auth["perm"],$this->user_id,$GLOBALS['auth']->auth["perm"], $this->public_sql);
                $sql .= sprintf(" UNION SELECT a.thema_id, a.artikel_id, a.titel, t.titel t_titel, a.mkdate, IFNULL(s.titel,'Unsortiert') subthema, IFNULL(s.subthema_id,a.thema_id) subthema_id, IF(STRCMP(s.titel,''),9999,1) priority FROM sb_artikel a LEFT JOIN sb_subthemen s USING (subthema_id), sb_themen t, sb_tag_artikel ta, sb_tags tt WHERE
                                t.thema_id=a.thema_id AND UNIX_TIMESTAMP() < (a.mkdate + %d) AND 
                                ta.artikel_id=a.artikel_id AND tt.tag_id=ta.tag_id AND LOWER(tt.tag) LIKE '%s' 
                                AND (t.visible=1 OR (t.visible=0 AND 'root'='%s')) AND (a.visible=1 OR (a.visible=0 AND (a.user_id='%s' OR 'root'='%s'))) %s ORDER BY priority DESC, subthema, 4,5 DESC,3 
                        ",$this->zeit,"%".strtolower($txt)."%",$GLOBALS['auth']->auth["perm"],$this->user_id,$GLOBALS['auth']->auth["perm"], $this->public_sql);
		$db->query($sql);
		while ($db->next_record())
			array_push($ret, $db->Record);
		return $ret;
	}

	function get_artikel($thema_id, $subthema_id='') {
                $ret = array();
                $db = new DB_Seminar();
                $db->queryf("SELECT a.* FROM sb_artikel a WHERE a.thema_id='%s' AND UNIX_TIMESTAMP() < (a.mkdate + %d) AND (a.visible=1 OR (a.visible=0 AND (a.user_id='%s' OR 'root'='%s'))) %s AND a.subthema_id='%s' ORDER BY mkdate DESC",$thema_id,$this->zeit,$this->user_id,$GLOBALS['auth']->auth["perm"], $this->public_sql, $subthema_id);
                while ($db->next_record()) {
                        $a = new Artikel($db->f("artikel_id"));
                        array_push($ret, $a);
                }
                return $ret;
        }

	function getSubThemen($tid) {
		$db = DBManager::get();
		$sql = sprintf("SELECT * FROM sb_subthemen WHERE thema_id='%s' ORDER BY titel",$tid);
		return $db->query($sql)->fetchAll();
	}

	function getSlogans() {
		$db = DBManager::get();
		$sql = "SELECT * FROM sb_slogans";
		return $db->query($sql)->fetchAll();
	}

	function insertSlogan($body, $author='') {
		$db = DBManager::get();
		$new_id = md5(uniqid(time().$body));
		$stmt = $db->prepare("INSERT INTO sb_slogans (slogan_id, body, author) VALUES (?, ?, ?)");
		$stmt->execute(array($new_id, $body, $author));
	}

	function insertSubThema($val, $tid) {
		$db = DBManager::get();
		$new_id = md5(uniqid(time().$tid));
		$stmt = $db->prepare("INSERT INTO sb_subthemen (subthema_id, thema_id, user_id, titel) VALUES (?, ?, ?, ?)");
		$stmt->execute(array($new_id, $tid, $GLOBALS['auth']->auth["uid"], $val));
	}

	function updateSubThema($val, $tid, $sid) {
		$db = DBManager::get();
		if (trim($val) == "") {
			$sql = sprintf("DELETE FROM sb_subthemen WHERE thema_id='%s' AND subthema_id='%s'",$tid, $sid);
			$db->query($sql);
			$sql = sprintf("UPDATE sb_artikel SET subtheme_id=NULL WHERE subthema_id='%s'",$sid);
			$db->query($sql);
		} else {
			$stmt = $db->prepare("UPDATE sb_subthemen SET titel=? WHERE thema_id=? AND subthema_id=?");
			$stmt->execute(array($val, $tid, $sid));
		}
	}

	function get_all_active_artikel() {
                $ret = array();
                $db = new DB_Seminar();
                $db->queryf("SELECT a.* FROM sb_artikel a WHERE UNIX_TIMESTAMP() < (a.mkdate + %d) AND (a.visible=1 OR (a.visible=0 AND (a.user_id='%s' OR 'root'='%s'))) %s ORDER BY mkdate DESC",$this->zeit,$this->user_id,$GLOBALS['auth']->auth["perm"], $this->public_sql);
                while ($db->next_record()) {
                        $a = new Artikel($db->f("artikel_id"));
                        array_push($ret, $a);
                }
                return $ret;
        }

	function is_duplicate($titel) {
                $db = new DB_Seminar();
                $db->queryf("SELECT artikel_id FROM sb_artikel WHERE user_id='%s' AND titel='%s' AND mkdate>(UNIX_TIMESTAMP()-60*60*24)",$this->user_id,$titel);
                if ($db->num_rows()>0)
                        return TRUE;
                else
                        return FALSE;
        }

	function get_artikel_lookups($artikel_id) {
                $db = new DB_Seminar();
                $db->queryf("SELECT * FROM sb_visits WHERE type='artikel' AND object_id='%s'",$artikel_id);
                return $db->num_rows();
        }

        function get_themen() {
                $ret = array();
                $db = new DB_Seminar();
                $query = sprintf("SELECT t.*, IFNULL(a.count_artikel,0) count_artikel FROM sb_themen t LEFT JOIN (SELECT thema_id, COUNT(artikel_id) count_artikel FROM sb_artikel WHERE UNIX_TIMESTAMP() < (mkdate + %d) GROUP BY thema_id) a USING (thema_id) WHERE t.visible=1 OR (t.visible=0 AND (t.user_id='%s' OR 'root'='%s')) ORDER BY count_artikel DESC",$this->zeit, $this->user_id,$GLOBALS['auth']->auth["perm"]);
                $db->query($query);
                while ($db->next_record()) {
                        $t = new ThemaExt($db->f("thema_id"));
                        $t->setArtikelCount($db->f("count_artikel"));
                        array_push($ret, $t);
                }
                return $ret;
        }

	function get_themen_sorted() {
                $ret = array();
                $db = new DB_Seminar();
                $query = sprintf("SELECT t.*, IFNULL(a.count_artikel,0) count_artikel FROM sb_themen t LEFT JOIN (SELECT thema_id, COUNT(artikel_id) count_artikel FROM sb_artikel WHERE UNIX_TIMESTAMP() < (mkdate + %d) GROUP BY thema_id) a USING (thema_id) WHERE t.visible=1 OR (t.visible=0 AND (t.user_id='%s' OR 'root'='%s')) ORDER BY t.titel",$this->zeit, $this->user_id,$GLOBALS['auth']->auth["perm"]);
                $db->query($query);
                while ($db->next_record()) {
                        $t = new ThemaExt($db->f("thema_id"));
                        $t->setArtikelCount($db->f("count_artikel"));
                        array_push($ret, $t);
                }
                return $ret;
        }

	function get_thema_perm($thema_id) {
                $db = new DB_Seminar();
                $db->queryf("SELECT perm FROM sb_themen WHERE thema_id='%s'",$thema_id);
                $db->next_record();
                return $db->f("perm");
        }

        function visit($obj_id, $type) {
                $db = new DB_Seminar();
                $db->queryf("REPLACE INTO sb_visits SET object_id='%s', user_id='%s', type='%s', last_visitdate=UNIX_TIMESTAMP()",$obj_id,$this->user_id,$type);
        }

        function has_visited($obj_id) {
                $db = new DB_Seminar();
                $db->queryf("SELECT last_visitdate FROM sb_visits WHERE object_id='%s' AND user_id='%s'",$obj_id,$this->user_id);
                if ($db->next_record())
                        return $db->f("last_visitdate");
                else
                        return FALSE;
        }

        function num_all_postings() {
                $db = new DB_Seminar();
                $db->query("SELECT * FROM sb_artikel");
                return $db->num_rows();
        }

        function new_items_since_last_visit_sorted() {
		$ret = array();
                $db = new DB_Seminar();
                $sql = sprintf("SELECT a.thema_id, COUNT(a.artikel_id) anz FROM sb_artikel a, sb_themen t WHERE UNIX_TIMESTAMP() < (a.mkdate + %d) AND a.visible=1 AND t.thema_id=a.thema_id AND t.visible=1 AND a.user_id!='%s' AND NOT EXISTS (SELECT object_id FROM sb_visits WHERE object_id=a.artikel_id AND type='artikel' AND user_id='%s') GROUP BY thema_id",$this->zeit,$this->user_id,$this->user_id);
		$db->query($sql);
		
		while ($db->next_record()) {
			$ret[$db->f('thema_id')] = $db->f('anz');
		}
		return (count($ret) ? $ret : FALSE);
        }

	function new_items_since_last_visit() {
                $db = new DB_Seminar();
                $db->queryf("SELECT last_visitdate FROM sb_visits WHERE user_id='%s' AND object_id='root'",$this->user_id);
                if ($db->next_record()) {
                        $lv = $db->f("last_visitdate");
                        $db->queryf("SELECT a.* FROM sb_artikel a, sb_themen t WHERE UNIX_TIMESTAMP() < (a.mkdate + %d) AND a.visible=1 AND t.thema_id=a.thema_id AND t.visible=1 AND a.mkdate>%d AND a.user_id!='%s' AND NOT EXISTS (SELECT object_id FROM sb_visits WHERE object_id=a.artikel_id AND type='artikel' AND user_id='%s')",$this->zeit,$lv,$this->user_id,$this->user_id);
                        return $db->num_rows();
                }
                return $this->num_all_postings();
        }

	function getTagCounter($limit=40) {
		$ret = array();
		$db = new DB_Seminar();
		$db->queryf("SELECT t.tag, COUNT(t.tag_id) anz FROM sb_tags t, sb_tag_artikel ta WHERE t.tag_id=ta.tag_id GROUP BY t.tag ORDER BY 2 DESC %s",($limit?"LIMIT 0,$limit":""));
		while ($db->next_record()) {
			$db->Record['tag_weight'] = $this->calcTagWeight($db->f('tag'));
			array_push($ret, $db->Record);
		}
		array_multisort($ret, SORT_ASC);
		return $ret;
	}

	function getMaxTagCount($single='') {
		$db = new DB_Seminar();
		if (!$single)
			$db->query("SELECT * FROM sb_tag_artikel");
		else
			$db->queryf("SELECT ta.* FROM sb_tag_artikel ta, sb_tags t WHERE ta.tag_id=t.tag_id AND t.tag='%s'",$single);
		return $db->num_rows();
	}

	function calcTagWeight($tag) {
		$f_max = 10;
		$t_i = $this->getMaxTagCount($tag);

		$db = new DB_Seminar();
                $db->queryf("SELECT MAX(x.anz) anz_max, MIN(x.anz) anz_min FROM (SELECT t.tag, COUNT(t.tag_id) anz FROM sb_tags t, sb_tag_artikel ta WHERE t.tag_id=ta.tag_id GROUP BY t.tag ORDER BY t.tag) x");
		$db->next_record();
		$anz_max = $db->f('anz_max');
		$anz_min = $db->f('anz_min');

		$delta = ($anz_max - $anz_min) / $f_max;
		$newThresholds = array();
		for ($x=1; $x<=$f_max; $x++) { 
			$newThresholds[$x] = 100 * log( ($anz_min + $x * $delta) + 2); 
		}

		$fontSet = false; 
		foreach ($newThresholds as $k=>$threshold) {
			if ( (100 * log($t_i+2) <= $newThresholds[$k]) && !$fontSet) { 
				$fontSet = true; 
				return $k;
			} 
		}
	}

	function garbageCollect() {
		$db = new DB_Seminar();
		$db2 = new DB_Seminar();
		// 30 Tage Sicherheitsabstand zum Loeschen
		$db->queryf("SELECT * FROM sb_artikel WHERE mkdate < (UNIX_TIMESTAMP() - %d - (30 * 24 * 60 * 60))", $this->zeit);
		while ($db->next_record()) {
			$a = new Artikel($db->f('artikel_id'));
			$a->delete();
			unset($a);
			$db2->query("DELETE FROM sb_visits WHERE type='artikel' AND object_id='%s'",$db->f('artikel_id'));
		}
		$db->query("SELECT t.* FROM sb_tags t WHERE owner!='root' AND NOT EXISTS (SELECT ta.artikel_id FROM sb_tag_artikel ta WHERE ta.tag_id=t.tag_id)");
		while ($db->next_record())
			$db->queryf("DELETE FROM sb_tags WHERE tag_id='%s' AND owner!='root'",$db->f('tag_id'));
	}

	function searchForTags($val) {
		$db = new DB_Seminar();
		$db->queryf("SELECT * FROM sb_tags WHERE LOWER(tag) LIKE LOWER('%s')",$val.'%');
		$ret = "<UL>";
		$suche = sprintf("/^(%s)/",$val);
		$ersetze = "<SPAN STYLE=\"font-weight:bold;\">\$1</SPAN>";
		while ($db->next_record()) {
			$txt = preg_replace($suche,$ersetze,$db->f('tag'));
			$ret .= "<LI>".$txt."</LI>";
		}
		$ret .= "</UL>";
		return $ret;
	}

}

?>
