<?php
/**
*
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
*
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// Copyright (C) 2009 Jan Kulmann <jankul@zmml.uni-bremen.de>
// ATTENTION: Please send ALL bug reports and security leaks directly to the author.
//            Thx!
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+


class AddSlogans extends DBMigration {

        function description () {
                return 'database changes to add slogans for schwarzes brett plugin';
        }

        function up () {
                $this->db->query("
CREATE TABLE IF NOT EXISTS `sb_slogans` (
  `slogan_id` varchar(32) NOT NULL,
  `body` text NOT NULL,
  `author` varchar(255) default NULL,
  PRIMARY KEY  (`slogan_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1");

		$this->db->query("
INSERT INTO `sb_slogans` (`slogan_id`, `body`, `author`) VALUES
('0d8743031ac78e9bdc0cb221b0ff0346', 'Im Entwurf zeigt sich das Talent, in der Ausfhrung die Kunst.', 'Marie von Ebner-Eschenbach'),
('596013a5f80abba3fab56c9de664f89c', 'Der Geist einer Sprache offenbart sich am deutlichsten in ihren unbersetzbaren Worten.', 'Marie von Ebner-Eschenbach'),
('c6acd1104a77db031b60b555fd5f340e', 'Wenn es einen Glauben gibt, der Berge versetzen kann, so ist es der Glaube an die eigene Kraft.', 'Marie von Ebner-Eschenbach'),
('357bce882ed9ae467db645a86616174a', 'Wer aufhrt, besser werden zu wollen, hrt auf, gut zu sein.', 'Marie von Ebner-Eschenbach'),
('4c217cf62baa8954fac3b3985dc7da77', 'Man muss schon etwas wissen, um verbergen zu knnen, dass man nichts wei.', 'Marie von Ebner-Eschenbach'),
('0d9690bd5d0338d31f0e6cf09ec79260', 'Seit die Mathematiker ber die Relativittstheorie hergefallen sind, verstehe ich sie selbst nicht mehr.', 'Albert Einstein'),
('a71a3c919abbca6b64ade067a874a413', 'Mach'' dir keine Sorgen wegen deiner Schwierigkeiten mit der Mathematik. Ich kann dir versichern, dass meine noch grer sind.', 'Albert Einstein'),
('6e010f6879de49eb79e8a8ed879890e8', 'Ich habe keine besondere Begabung, sondern bin nur leidenschaftlich neugierig.', 'Albert Einstein'),
('6275f5d56ceb1654eea6b252f66b4929', 'Zwei Dinge sind unendlich, das Universum und die menschliche Dummheit, aber bei dem Universum bin ich mir noch nicht ganz sicher.', 'Albert Einstein'),
('519f5bf2b178e4b35575740ec95f4a3a', 'Das schnste Glck des denkenden Menschen ist, das Erforschliche erforscht zu haben und das Unerforschliche zu verehren.', 'Johann Wolfgang von Goethe'),
('337baf3c008933fb16f194d2cb62ca09', 'Nichts ist schrecklicher als ein Lehrer, der nicht mehr wei als das, was die Schler wissen sollen.', 'Johann Wolfgang von Goethe'),
('f35e4d8331e1c52a1acd704fd7bad422', 'Mit dem Wissen wchst der Zweifel.', 'Johann Wolfgang von Goethe'),
('4dcb5ec8a58957e9d858d5d9a9269514', 'Auch aus Steinen, die einem in den Weg gelegt werden, kann man Schnes bauen.', 'Johann Wolfgang von Goethe'),
('1ccccae479ceb01f1d926e2be03eec2c', 'Derjenige, der etwas zerbricht, um herauszufinden, was es ist, hat den Pfad der Weisheit verlassen.', 'J.R.R. Tolkien'),
('aefaab75472e050d48c77cf2f22996c7', 'Einer Sache sollte nicht ihrer uerlichkeit wegen der Vorzug gegeben werden, die Auswahl sollte anhand ihrer Nachhaltigkeit geschehen.', 'Jan Kulmann'),
('6fa961a3b79170120ad24eb50b50c378', 'Architecture is relative. What you think architecture is depends on what you are doing.', 'John A. Zachman, 1999'),
('92af9d1d85889307793eb94f4c49a77e', 'Es gibt keine schlechten Schler, es gibt nur miserable Lernmethoden.', 'Sebastian Leitner, 2004'),
('207cb8bf1bf0f0acb503386c2fd6f0b2', 'Imagination is more important than knowledge.', 'Albert Einstein'),
('d9d06ad78572365934a02bc7a94e8dc8', 'Better to reign in Hell, than serve in Heaven.', '(Paradise Lost Buch 1, John Milton 1608 - 1674, englischer Dichter und Staatsphilosoph)'),
('c94e275f46363cf49fd3a073219508a9', '... to find one friend one must close one eye; to keep him, two.', 'Norman Douglas'),
('61cd6940c4baaf1bb044eb667aef7fb9', 'Wenn die Neugier sich auf ernsthafte Dinge richtet, dann nennt man sie Wissensdrang.', 'Marie von Ebner-Eschenbach'),
('22a4bc990653e3f243eb744ff4a6de9f', 'Quality means doing it right when no one is looking.', 'Henry Ford'),
('0224efb5e8625a846d4e1d02e5ec8429', 'Coffee in England always tastes like a chemistry experiment.', 'Agatha Christie'),
('2fe3e8a4e89341f4a992f205ffb81914', 'Die Geshichte lehrt die Menschen, dass die Geschichte die Menschen nichts lehrt.', 'Mahatma Ghandi'),
('ad2175ca5ba6dc24de911df3c96f2571', 'Zu wissen, was man wei, und zu wissen, was man tut, das ist Wissen.', 'Konfuzius')
");
        }

        function down () {
                $this->db->query("DROP TABLE `sb_slogans`");
        }

}

?>
